class DAFile;
class DATooth;

class DALine
{
public:
	DALine( DAFile* file, int text, int up, int low );
	~DALine(void);

	int text() { return textID; };
	int upperRev() { return upper; };
	int lowerRev() { return lower; };

	DAFile* getFile() { return file; };

	DALine* nextLine() { return next; };
	DALine* prevLine() { return prev; };

	DALine* nextAsOf( int rev );
	DALine* prevAsOf( int rev );

	DALine* nextToothed();
	DALine* prevToothed();

	void prependLine( DALine* line );

	void setTooth( DATooth* t ) { tooth = t; };
	DATooth* getTooth() { return tooth; };

	bool zipped() { return anc != 0x0; };
	DALine* ancestor();
	void setAncestor( DALine* a ) { if ( !anc ) anc = a; };

private:
	int textID;

	int upper;
	int lower;

	DALine* prev;
	DALine* next;

	DAFile* file;

	DALine* anc;

	DATooth* tooth;
};
